#include "sysincludes.h"



//=========================================================
//ӳ:tӳʱ
//ӳ:none
//ӳ:ʱ
//=========================================================
void LCD_Delayus( unsigned int t )
{
	while(t--);
}


//=========================================================
//ӳ:value
//ӳ:none
//ӳ:RS=0;RW=0ʱдָ
//=========================================================
void LCD_wr_com( unsigned char com )
{
	E_clear;
	RS_clear;//
	RW_clear;//д״̬
	IO0CLR = 0xFF;
	IO0SET = com;//λ
	E_set;
//	LCD_Delayus(10); //ûʱͱҪӲæָ
	E_clear;
//	LCD_Delayus(1);
}




//=========================================================
//ӳ:sj
//ӳ:none
//ӳ:RS=1;RW=0ʱдݺ
//=========================================================
void LCD_wr_data( unsigned char data )
{
	E_clear;
	RS_set;//
	RW_clear;//д״̬
//	LCD_Delayus(1);
	IO0CLR = 0xFF;
	IO0SET = data;//λ
	E_set;
//	LCD_Delayus(10);//ûʱͱҪӲæָ
	E_clear;
//	LCD_Delayus(1);
}





//=========================================================
//ӳ:
//ӳ:ȡ
//ӳ:ݺ
//=========================================================
unsigned char LCD_rd_data( void )
{
	unsigned char sj;
	IO0SET |= 0xFF;
	E_clear;
	RS_set;
	RW_set;
	LCD_Delayus(1);
	E_set;
	LCD_Delayus(10);//ûʱͱҪӲæָ
	sj = ( unsigned char )IO0SET;
	E_clear;
	return sj;	
}






//=========================================================
//ӳ: x
//            y: 
//            colorɫ
//ӳ: none
//ӳ:㺯
//=========================================================
void LCD_Draw_Point( unsigned int x , unsigned int y , unsigned int color )
{
	LCD_wr_com( x % 256 ); 
	LCD_wr_com( x / 256 );
	 
	LCD_wr_com( y ); 
	LCD_wr_com( 0 );

	LCD_wr_data( color % 256 );
	LCD_wr_data( color / 256 );
}




//=========================================================
//ӳ: x1 1x
//            y1 1y
//            x2 2x
//            y2 2y
//            color:ɫ
//ӳ: none
//ӳ: ҺӦɫ
//=========================================================
void LCD_ClearRent( unsigned int x1 , unsigned int y1 , unsigned int x2 , unsigned int y2 , unsigned int color )
{
	unsigned int i,j;
	for( i=x1 ; i<x2 ; i++ )
		for( j=y1 ; j<y2 ; j++ )
			LCD_Draw_Point(i,j,color);	
}






//=========================================================
//ӳ: X    :
//            Y    :
//            *c   :ָ
//            color:ɫ
//ӳ: none
//ӳ: 16*16ֵʾ(ԭ)
//=========================================================
#include "16x16.h" //16*16ģ
void LCD_HZ1616(unsigned int X, unsigned int Y, unsigned char *c, unsigned int color) 
{ 
	unsigned int k,i,j,hz_i;
	  
	for( hz_i = 0; hz_i < HANZI_KU_SIZE; hz_i++ )
		if( (hz_code_16[hz_i].Index[0] == *c) && (hz_code_16[hz_i].Index[1] == *(c+1)) )//˶Ժ
			for( j = 0; j < 16; j++ ) //
				for( i = 0; i < 16; i++ )  //
				{ 
					k = i % 8; 
 
					if( hz_code_16[hz_i].Msk[j * 2 + i / 8]  & (0x80 >> k) ) //жÿиǷɫ
						LCD_Draw_Point( i + X , j + Y , color);
				} 	 
}





//=========================================================
//ӳ: x1:ֱ
//            y1:ֱ
//            x2:ֱյ
//            y2:ֱյ
//ӳ: none
//ӳ: ֱ
//=========================================================
void LCD_draw_line(unsigned int x1 , unsigned int y1 , unsigned int x2 , unsigned int y2)
{
	unsigned int x = x1 << 8,y = y1 << 8;     //8λΪֵ8λΪۼ
	int dx = x2 - x1, dy = y2 - y1;

	while( abs(dx) < 64 && abs(dy) < 64 && dx * dy != 0 ) 
	{
		dx*=6;
		dy*=6;
	} //岹ٶ	 //2

	while( (x >> 8) != x2 || (y >> 8) != y2)
	{
		LCD_Draw_Point( x>>8, y>>8 , 0xffff);
		x += dx;
		y += dy;
	}

	LCD_Draw_Point( x>>8 , y>>8 , 0xffff );
}






//=========================================================
//ӳ: x:Բ
//            y:Բ
//            r:Բ뾶
//ӳ: none
//ӳ: Բ
//=========================================================
void LCD_draw_round(unsigned int x , unsigned int y , unsigned int r)
{
	float angle;
	unsigned char dx,dy;
	for(angle=0; angle < 3.14 / 4; angle+=0.03)//0.03
	{
		dx = r * sin(angle);
		dy = r * cos(angle);

		LCD_Draw_Point( x + dx, y + dy , 0xffff );
		LCD_Draw_Point( x - dx, y + dy , 0xffff );
		LCD_Draw_Point( x + dx, y - dy , 0xffff );
		LCD_Draw_Point( x - dx, y - dy , 0xffff );
		LCD_Draw_Point( x + dy, y + dx , 0xffff );
		LCD_Draw_Point( x - dy, y + dx , 0xffff );
		LCD_Draw_Point( x + dy, y - dx , 0xffff );
		LCD_Draw_Point( x - dy, y - dx , 0xffff );
	}
}








//=========================================================
//ӳ:*ptrָͼƬ
//ӳ:none
//ӳ:ͼ
//=========================================================
void LCD_Draw_Picture( unsigned short *ptr )
{
	unsigned short i,j;
	
	for( i=0 ; i<240 ; i++ )//ʾһ320240ͼƬ
	{
		for( j=0 ; j<320 ; j++)
			LCD_Draw_Point( j , i , ptr[i*320+j] );
	}
}



//=========================================================
//ӳ: X    :
//            Y    :
//            c    :ASCII
//            color:ɫ
//ӳ: none
//ӳ: 8*8 ASCIIʾ
//=========================================================
#include"8x8.h"//8*8 ASCIIģ
void LCD_char88(unsigned int X, unsigned int Y, char c, unsigned int color)
{ 
	unsigned char k,i,j;  

	for( j = 0; j < 8; j++ ) //
		for( i = 0; i < 8; i++ )  //
		{ 
			k = i ;
			if( Font8x8[c][j]  & (0x80 >> k) ) //жÿиǷɫ
				LCD_Draw_Point( i + X, j + Y , color);
		} 
}





//=========================================================
//ӳ: X    :
//            Y    :
//            c    :ASCII
//            color:ɫ
//ӳ: none
//ӳ: 8*16 ASCIIʾ
//=========================================================
#include"8x16.h"//8*16 ASCIIģ
void LCD_char816( unsigned int X , unsigned int Y , char c , unsigned int color )
{ 
	unsigned char k,i,j;  

	for( j=0; j<16; j++ ) //
		for( i=0; i<8; i++ )  //
		{ 
			k = i ;
			if( Font8x16[c][j] & (0x80 >> k) ) //жÿиǷɫ
				LCD_Draw_Point( i + X, j + Y , color );
		} 
}





//=========================================================
//ӳ: x        :
//            y        :
//            *s       :ַ
//            color    :ɫ
//            char_font:ASCIIСѡ(1:8*160:8*8)
//ӳ: none
//ӳ: ַʾ
//=========================================================
void LCD_PutString( unsigned int x , unsigned int y, char *s , unsigned int color , unsigned char char_font ) 
{
	unsigned int l = 0;
	while( *s ) 
	{
		if( *s < 0x80 ) 
		{
			if( char_font == 1 )
				LCD_char816( x + l * 8 , y , *s , color );
			else
				LCD_char88 ( x + l * 8 , y , *s , color );
			s++;
			l++;
		}				 
		else
		{
			LCD_HZ1616( x + l * 8 , y , (unsigned char *)s , color );
			s += 2;
			l += 2;
		}
	}
}







/*
//=========================================================
//ӳ: *strַָָ
//ӳ: ַ
//ӳ:ַ
//=========================================================
unsigned int Sstrlen(const uchar *str)
{
	
	const uchar *p;
	p = str;
	assert(str); 
	while(*p++!=NULL); 
	return p-str-1;
}




//=========================================================
//ӳ: x
//            y: 
//            *ddָҪʾַ
//            colorɫ
//            Bcolorɫ
//ӳ: none
//ӳ:ַʾĺ(Զ)
//=========================================================
void DisplaycharsAuto(uint x,uint y, const uchar *dd,uint color,uint Bcolor,uint t)
{
	unsigned int len,i,k=0,yd=0;
	len = Sstrlen(dd);
	DisplayoneChar(x,y,*dd,color,Bcolor);
	k = 1;
	for(i=1;i<len;i++)
	{
		if(*(dd+i)=='\n')   
		{
			yd += 16;
			k = 0;
			x = 0;
			continue;
		}
		else if(x+(k+1)*8>320)
		{
			yd += 16;
			k = 0;
			x = 0;
		}
		if(y+yd+16>240) break;
		DisplayoneChar(x+k*8,y+yd,*(dd+i),color,Bcolor);
		k++;
		LCD_Delayms(t);
	}
}
*/
